Attribute VB_Name = "tcEngine"
'Option Explicit
Sub InitTCApp()
    On Error GoTo ErrH
    If (bInit = False) Then
        Set xtcApp = New IMSIGX.XApplication
        Set Drs = xtcApp.Drawings
        'Set Rs = xtcApp.Renders

    End If
Exit Sub
ErrH:
    MsgBox Err.Description
End Sub
Sub DestroyAll()
    On Error Resume Next
    Err.Clear
    If Not V Is Nothing Then
        V.Delete
    End If
    Set V = Nothing
    If Not xtcDr Is Nothing Then
        xtcDr.Close False
    End If
    Set xtcDr = Nothing
    Set Drs = Nothing
    If Not xtcApp Is Nothing Then
        xtcApp.Quit
    End If
    Set xtcApp = Nothing

End Sub

Public Sub addPreview(pPreviewCtrl As PictureBox)
    On Error GoTo ErrH
    Set pViews = xtcDr.Views
    Set V = pViews.Add
    V.MappingMode = 1
    V.hwnd = pPreviewCtrl.hwnd
    V.ViewLeft = pPreviewCtrl.Left
    V.ViewTop = pPreviewCtrl.Top
    V.ViewHeight = pPreviewCtrl.Height
    V.ViewWidth = pPreviewCtrl.Width
    V.FixedAspectRatio = True
    
    V.AutoRedraw = False
    V.Update = False
    If (xtcDr.Properties("TileMode") = 1) Then
        V.SpaceMode = imsiModelSpace
        Call SetView(V, TC_VISO_SE)
    Else
        V.SpaceMode = imsiPaperSpace
    End If
    
    pPreviewCtrl.Refresh
    If (V.SpaceMode = imsiModelSpace) Then
        Call SetView(V, TC_VISO_SE)
        V.AutoRedraw = True
        V.Refresh
    Else
        V.ZoomToExtents
        V.AutoRedraw = True
    End If
Exit Sub
ErrH:
    MsgBox Err.Description

End Sub


Public Function SelectGraphic(xScreen As Double, yScreen As Double) As Graphic

    Dim xView As Double, yView As Double
    Dim gxPickResult As PickResult
    Dim gxPickEntry As PickEntry
    V.ScreenToView xScreen, yScreen, xView, yView
    'Set gxPickResult = V.PickPoint(xView, yView) ',,, , ref missing,ref missing, ref missing,ref missing);
    Set gxPickResult = V.PickPoint(xView, yView) ',,, , ref missing,ref missing, ref missing,ref missing);
    
    Dim apert As Double, x0 As Double, y0 As Double, x1 As Double, y1 As Double
    apert = xtcApp.Properties("Aperture")
    V.ScreenToView 0, 0, x0, y0
    V.ScreenToView 0, apert, x1, y1
    apert = (x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0)
    If (gxPickResult.Count <> 0) Then
        Set gxPickEntry = gxPickResult(0)
        If (gxPickEntry.Distance <= apert) Then
            Set SelectGraphic = gxPickEntry.Graphic
        End If
    Else
        xtcDr.Graphics.Unselect
    End If
End Function
Public Function GetNearestVertex(xScreen As Double, yScreen As Double) As Vertex
    Dim xView As Double, yView As Double
    Dim gxPickResult As PickResult
    Dim gxPickEntry As PickEntry
    V.ScreenToView xScreen, yScreen, xView, yView
    'Set gxPickResult = V.PickPoint(xView, yView) ',,, , ref missing,ref missing, ref missing,ref missing);
    Set gxPickResult = V.PickPoint(xView, yView) ',,, , ref missing,ref missing, ref missing,ref missing);
    
    Dim apert As Double, x0 As Double, y0 As Double, x1 As Double, y1 As Double
    apert = xtcApp.Properties("Aperture")
    V.ScreenToView 0, 0, x0, y0
    V.ScreenToView 0, apert, x1, y1
    apert = (x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0)
    If (gxPickResult.Count <> 0) Then
        Set gxPickEntry = gxPickResult(0)
        If (gxPickEntry.Distance <= apert) Then
            'Set GetNearestVertex = gxPickEntry.ClosestVertex
            Set GetNearestVertex = gxPickEntry.ClosestSegmentVertex
        End If
    Else
        xtcDr.Graphics.Unselect
    End If
End Function


