VERSION 5.00
Begin VB.Form dlgTCADEvents 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Select TCAD Events"
   ClientHeight    =   3195
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   6030
   Begin VB.ListBox lstEvents 
      Height          =   2790
      Left            =   120
      MultiSelect     =   1  'Simple
      TabIndex        =   2
      Top             =   120
      Width           =   3972
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "dlgTCADEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2001                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'

Option Explicit

Public mask As Long
Public bOK As Boolean

Public coords As New dlgCoords

Private Sub CancelButton_Click()
    Hide
End Sub

Private Sub Form_Activate()
    bOK = False
End Sub

Private Sub Form_Load()
    Dim indItem As Long
    indItem = 0
    
    lstEvents.AddItem "BeforeExit", indItem
    lstEvents.ItemData(indItem) = imsiEventBeforeExit
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingNew", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingNew
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingOpen", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingOpen
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingActivate", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingActivate
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingDeactivate", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingDeactivate
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingBeforeClose", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingBeforeClose
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingBeforeSave", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingBeforeSave
    
    indItem = indItem + 1
    lstEvents.AddItem "MouseDown", indItem
    lstEvents.ItemData(indItem) = imsiEventMouseDown
    
    indItem = indItem + 1
    lstEvents.AddItem "MouseUp", indItem
    lstEvents.ItemData(indItem) = imsiEventMouseUp
    
    indItem = indItem + 1
    lstEvents.AddItem "MouseMove", indItem
    lstEvents.ItemData(indItem) = imsiEventMouseMove
    
    indItem = indItem + 1
    lstEvents.AddItem "BeforeDoubleClick", indItem
    lstEvents.ItemData(indItem) = imsiEventBeforeDoubleClick
    
    indItem = indItem + 1
    lstEvents.AddItem "BeforeRightClick", indItem
    lstEvents.ItemData(indItem) = imsiEventBeforeRightClick
    
    indItem = indItem + 1
    lstEvents.AddItem "SelectionChange", indItem
    lstEvents.ItemData(indItem) = imsiEventSelectionChange
    
    indItem = indItem + 1
    lstEvents.AddItem "RunTool", indItem
    lstEvents.ItemData(indItem) = imsiEventRunTool
    
    indItem = indItem + 1
    lstEvents.AddItem "Drop", indItem
    lstEvents.ItemData(indItem) = imsiEventDrop
    
    indItem = indItem + 1
    lstEvents.AddItem "DrawingAfterSave", indItem
    lstEvents.ItemData(indItem) = imsiEventDrawingAfterSave
    
    bOK = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload coords
End Sub

Private Sub OKButton_Click()
    Dim nCnt As Long
    Dim indItem As Long
    nCnt = lstEvents.ListCount() - 1

    mask = 0

    For indItem = 0 To nCnt
        If (lstEvents.Selected(indItem)) Then
            mask = mask + lstEvents.ItemData(indItem)
        End If
    Next indItem

    bOK = True
    Hide
End Sub

Public Sub BeforeDoubleClick(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Sel As IMSIGX.Selection, Cancel As IMSIGX.IMSI_BOOL)
    Cancel = False
End Sub

Public Sub BeforeExit(ByVal TheApp As IMSIGX.IApplication, Cancel As IMSIGX.IMSI_BOOL)
    Cancel = False
End Sub

Public Sub BeforeRightClick(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Sel As IMSIGX.Selection, Cancel As IMSIGX.IMSI_BOOL)
    Cancel = False
End Sub

Public Sub DrawingActivate(ByVal WhichDrawing As IMSIGX.IDrawing)

End Sub

Public Sub DrawingAfterSave(ByVal WhichDrawing As IMSIGX.IDrawing)

End Sub

Public Sub DrawingBeforeClose(ByVal WhichDrawing As IMSIGX.IDrawing, Cancel As IMSIGX.IMSI_BOOL)
    Cancel = False
End Sub

Public Sub DrawingBeforeSave(ByVal WhichDrawing As IMSIGX.IDrawing, SaveAs As IMSIGX.IMSI_BOOL, Cancel As IMSIGX.IMSI_BOOL)
    Cancel = False
End Sub

Public Sub DrawingDeactivate(ByVal WhichDrawing As IMSIGX.IDrawing)

End Sub

Public Sub DrawingNew(ByVal WhichDrawing As IMSIGX.IDrawing)
    
End Sub

Public Sub DrawingOpen(ByVal WhichDrawing As IMSIGX.IDrawing)

End Sub

Public Sub Drop(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Sel As IMSIGX.Selection)

End Sub

Public Sub MouseDown(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Button As IMSIGX.ImsiMouseButton, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long, Cancel As IMSIGX.IMSI_BOOL)
    Dim XScreen As Double
    Dim YScreen As Double
    Dim XView As Double
    Dim YView As Double
    Dim XWorld As Double
    Dim YWorld As Double
    Dim ZWorld As Double
    
    XScreen = X
    YScreen = Y
    
    coords.txtX1.Text = CStr(X)
    coords.txtY1.Text = CStr(Y)
    
    WhichView.ScreenToView XScreen, YScreen, XView, YView
    WhichView.ViewToWorld XView, YView, 0#, XWorld, YWorld, ZWorld
    
    coords.txtX2.Text = CStr(XView)
    coords.txtY2.Text = CStr(YView)
    
    coords.txtX3 = CStr(XWorld)
    coords.txtY3 = CStr(YWorld)
    coords.txtZ3 = CStr(YWorld)
    
    coords.Show vbModeless
    Cancel = False
End Sub

Public Sub MouseMove(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long, Cancel As IMSIGX.IMSI_BOOL)
    Dim XScreen As Double
    Dim YScreen As Double
    Dim XView As Double
    Dim YView As Double
    Dim XWorld As Double
    Dim YWorld As Double
    Dim ZWorld As Double
    
    XScreen = X
    YScreen = Y
    
    coords.txtX1 = CStr(X)
    coords.txtY1 = CStr(Y)
    
    WhichView.ScreenToView XScreen, YScreen, XView, YView
    WhichView.ViewToWorld XView, YView, 0#, XWorld, YWorld, ZWorld
    
    coords.txtX2 = CStr(XView)
    coords.txtY2 = CStr(YView)
    
    coords.txtX3 = CStr(XWorld)
    coords.txtY3 = CStr(YWorld)
    coords.txtZ3 = CStr(YWorld)
    
    coords.Show vbModeless
    Cancel = False
End Sub

Public Sub MouseUp(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Button As IMSIGX.ImsiMouseButton, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long, Cancel As IMSIGX.IMSI_BOOL)
    Dim XScreen As Double
    Dim YScreen As Double
    Dim XView As Double
    Dim YView As Double
    Dim XWorld As Double
    Dim YWorld As Double
    Dim ZWorld As Double
    
    XScreen = X
    YScreen = Y
    
    coords.txtX1 = CStr(X)
    coords.txtY1 = CStr(Y)
    
    WhichView.ScreenToView XScreen, YScreen, XView, YView
    WhichView.ViewToWorld XView, YView, 0#, XWorld, YWorld, ZWorld
    
    coords.txtX2 = CStr(XView)
    coords.txtY2 = CStr(YView)
    
    coords.txtX3 = CStr(XWorld)
    coords.txtY3 = CStr(YWorld)
    coords.txtZ3 = CStr(YWorld)
    
    coords.Show vbModeless
    Cancel = False
End Sub

Public Sub RunTool(ByVal WhichTool As IMSIGX.Tool)

End Sub

Public Sub SelectionChange(ByVal WhichDrawing As IMSIGX.IDrawing, ByVal WhichView As IMSIGX.View, ByVal WhichWindow As IMSIGX.Window, ByVal Sel As IMSIGX.Selection)

End Sub

