Attribute VB_Name = "tcCamera"
Public Sub SetView(ByVal pView As View, ByVal iViewType As Long)
    Dim dxPos As Double
    Dim dyPos As Double
    Dim dzPos As Double
    Dim dxLook As Double
    Dim dyLook As Double
    Dim dzLook As Double
    Dim dxUp As Double
    Dim dyUp As Double
    Dim dzUp As Double
    Dim pCam As IMSIGX.XCamera
    Dim xPVpos As IMSIGX.XVertex
    Dim xPVLook As IMSIGX.XVertex
    Dim xPVUp As IMSIGX.XVertex
    
    On Error GoTo ErrH
    Select Case (iViewType)
        Case TC_VPLAN:
                dxPos = 0
                dyPos = 0
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 1
                dzUp = 0
        Case TC_VLEFT:
                dxPos = -1
                dyPos = 0
                dzPos = 0
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VRIGHT:
                dxPos = 1
                dyPos = 0
                dzPos = 0
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VFRONT:
                dxPos = 0
                dyPos = -1
                dzPos = 0
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VBOTTOM:
                dxPos = 0
                dyPos = 0
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = -1
                dzUp = 0
        Case TC_VISO_SE:
                dxPos = 1
                dyPos = -1
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VISO_SW:
                dxPos = -1
                dyPos = -1
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VISO_NE:
                dxPos = 1
                dyPos = 1
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case TC_VISO_NW:
                dxPos = -1
                dyPos = 1
                dzPos = 1
            
                dxLook = 0
                dyLook = 0
                dzLook = 0

                dxUp = 0
                dyUp = 0
                dzUp = 1
        Case Else
            Exit Sub
    End Select
    
    Set pCam = pView.Camera
    Set xPVpos = pCam.Location
    Set xPVLook = xPVpos.Duplicate
    Set xPVUp = xPVpos.Duplicate
    xPVpos.X = dxPos
    xPVpos.Y = dyPos
    xPVpos.Z = dzPos
    
    xPVLook.X = dxLook
    xPVLook.Y = dyLook
    xPVLook.Z = dzLook
    
    xPVUp.X = dxUp
    xPVUp.Y = dyUp
    xPVUp.Z = dzUp
    
    pCam.CameraSetSpaceParameters xPVpos, xPVLook, xPVUp
    
'---------------------------------------
''    Tree1.Refresh
'---------------------------------------
    
    
    pView.ZoomToExtents
'---------------------------------------
    Set xPVpos = pCam.Location
    pCam.Location = xPVpos
'---------------------------------------
'    Call DoRenderEx
    Exit Sub
ErrH:
    MsgBox Err.Description
    Set xPVpos = Nothing
    Set xPVLook = Nothing
    Set xPVUp = Nothing
    Set pCam = Nothing

End Sub


