VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmEvents 
   Caption         =   "Select Events"
   ClientHeight    =   3984
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3468
   OleObjectBlob   =   "frmEvents.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2001                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'

Option Explicit

Private Sub FillListBox()
    On Error Resume Next
    
    lstEvents.ColumnCount = 2
    lstEvents.ColumnWidths = "-1;0"
    lstEvents.TextColumn = 1
    
    lstEvents.AddItem "BeforeExit"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventBeforeExit
    
    lstEvents.AddItem "DrawingNew"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingNew
    
    lstEvents.AddItem "DrawingOpen"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingOpen
    
    lstEvents.AddItem "DrawingActivate"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingActivate
    
    lstEvents.AddItem "DrawingDeactivate"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingDeactivate
    
    lstEvents.AddItem "DrawingBeforeClose"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingBeforeClose
    
    lstEvents.AddItem "DrawingBeforeSave"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingBeforeSave
    
    lstEvents.AddItem "MouseDown"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventMouseDown
    
    lstEvents.AddItem "MouseUp"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventMouseUp
    
    lstEvents.AddItem "MouseMove"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventMouseMove
    
    lstEvents.AddItem "BeforeDoubleClick"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventBeforeDoubleClick
    
    lstEvents.AddItem "BeforeRightClick"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventBeforeRightClick
    
    lstEvents.AddItem "SelectionChange"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventSelectionChange
    
    lstEvents.AddItem "RunTool"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventRunTool
    
    lstEvents.AddItem "Drop"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrop
    
    lstEvents.AddItem "DrawingAfterSave"
    lstEvents.List(lstEvents.ListCount - 1, 1) = imsiEventDrawingAfterSave
End Sub

Public Function GetEventMask() As Long
    On Error Resume Next
    Dim nCnt As Long
    Dim indItem As Long
    Dim mask As Long
    mask = 0
    nCnt = lstEvents.ListCount() - 1
    For indItem = 0 To nCnt
        If lstEvents.Selected(indItem) Then
            mask = mask + CLng(lstEvents.List(indItem, 1))
        End If
    Next indItem
    GetEventMask = mask
End Function

Private Sub btnClearAll_Click()
    Dim c1 As Variant
    Dim c2 As Variant
    Dim nCnt As Long
    Dim indItem As Long
    nCnt = lstEvents.ListCount() - 1
    For indItem = 0 To nCnt
        If lstEvents.Selected(indItem) Then
            c1 = lstEvents.List(indItem, 0)
            c2 = lstEvents.List(indItem, 1)
            lstEvents.RemoveItem indItem
            lstEvents.AddItem c1, indItem
            lstEvents.List(indItem, 1) = c2
        End If
    Next indItem
End Sub

Private Sub btnOK_Click()
    Me.Hide
End Sub

Private Sub UserForm_Activate()
    If lstEvents.ListCount = 0 Then FillListBox
End Sub

