Attribute VB_Name = "Output_Attributes"
Option Explicit
Dim grs As Graphics, gr As Graphic
Dim blks As Blocks, blk As Block
Dim GrCount As Integer, BlkCount As Integer
Dim props As Properties, prop As Property
Dim i As Integer, j As Integer
Dim THISTEXT As String

Public Sub Print_Block_Attributes()
Dim grs As Graphics, gr As Graphic
Dim i As Integer
    Set grs = ActiveDrawing.Graphics
    Set gr = grs(0)
    Debug.Print "Block"; " "; "Attribute"; " = "; "Value"
    For Each gr In grs
        For i = 1 To gr.Attributes.Count - 1
            Debug.Print gr.Block.Name; " "; gr.Attributes.Item(i).Name; " = "; gr.Attributes(i).Value
        Next i
    Next gr
End Sub

Public Sub Print_Prop_If_IsAttribute()
'On Error Resume Next
    On Error Resume Next
    Set grs = ActiveDrawing.Graphics
    Set gr = grs(0)
    Set props = gr.Properties
    Set prop = gr.Properties(0)
    For Each gr In grs
    Debug.Print vbNewLine; gr.Name
        For Each prop In props
        If prop.IsAttribute Then
                Debug.Print prop.Name; " = "; prop.Value
        End If
        Next prop
    Next gr
    
End Sub


Public Sub Output_All_Attributes()
    On Error Resume Next
    Dim grs As Graphics, gr As Graphic
    Dim vts As Vertices, vtx As Vertex
    Dim AppPath$, FName$
    Dim hFile As Long
    
    'Return the complete path of the Application, as a string, _
     without including the final separator and name of the object
    AppPath = ActiveDrawing.Application.Path
    hFile = FreeFile 'Returns an Integer representing the next file number _
                        available for use by the Open statement
    
    Dim GetName
   GetName = InputBox("Enter a 1 word name for your .csv file" & vbNewLine & _
                "That will be saved in the /Programs Folder", "Input File Name", "Attributes")

    'String togrther some relative Graphic Info for the file name
    FName = AppPath & "\" & GetName & ".csv"
    
    'Enable input/output (I/O) to a file.
    Open FName For Output As hFile ' creates  and opens the file for sequential output
    
    Set grs = ActiveDrawing.Graphics
    Set gr = grs(0)
    Set props = gr.Properties
    Set prop = gr.Properties(0)
    
    Write #hFile, "Attribute"; "Value"
    
    For Each gr In grs
    Debug.Print vbNewLine; gr.Name
        For Each prop In props
        If prop.IsAttribute Then
                Write #hFile, prop.Name; prop.Value
        End If
        Next prop
    Next gr

    Close #hFile    ' Close file.
    Debug.Print FName
    InputBox "Copy the whole thing" & vbNewLine & _
            "and paste it into the Open Dialog of Notepad" & vbNewLine & _
            "or a Spreadsheet or any database" & vbNewLine & _
            "that reads a CSV file", "This is your Output File Name", FName

End Sub

